# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_with bootstrap
%bcond_with maven
%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/apache-bcel/5.1-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define section free

Name:           bcel
Version:        5.1
Release:        16%{?dist}
Epoch:          0
Summary:        Byte Code Engineering Library
License:        ASL 2.0
URL:            http://jakarta.apache.org/%{name}/
Group:          Development/Libraries/Java
# svn -q export https://svn.apache.org/repos/asf/jakarta/bcel/tags/BCEL_5_1
Source0:        bcel-5.1-src.tar.gz
Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        bcel-5.1-jpp-depmap.xml
Source5:        bcel-jakarta-site2.tar.gz
Source6:        bcel-5.1-component-info.xml
Source7:        bcel-%{version}.pom
Patch0:         bcel-5.1-build.patch
Patch1:         bcel-5.1-project_xml.patch
Requires:       regexp
BuildRequires:  ant
BuildRequires:  regexp
BuildRequires:  jpackage-utils >= 0:1.6
%if %with maven
BuildRequires:  maven >= 0:1.1
BuildRequires:  saxon
BuildRequires:  saxon-scripts
%endif
%if %without bootstrap
BuildRequires:  jdom
BuildRequires:  velocity
BuildRequires:  jakarta-commons-collections
BuildRequires:  jakarta-commons-lang
BuildRequires:  excalibur-avalon-logkit
BuildRequires:  werken.xpath
%endif
%if %{gcj_support}
BuildRequires:  java-gcj-compat-devel
%else
BuildArch:      noarch
%endif
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The Byte Code Engineering Library (formerly known as JavaClass) is
intended to give users a convenient possibility to analyze, create, and
manipulate (binary) Java class files (those ending with .class). Classes
are represented by objects which contain all the symbolic information of
the given class: methods, fields and byte code instructions, in
particular.  Such objects can be read from an existing file, be
transformed by a program (e.g. a class loader at run-time) and dumped to
a file again. An even more interesting application is the creation of
classes from scratch at run-time. The Byte Code Engineering Library
(BCEL) may be also useful if you want to learn about the Java Virtual
Machine (JVM) and the format of Java .class files.  BCEL is already
being used successfully in several projects such as compilers,
optimizers, obsfuscators and analysis tools, the most popular probably
being the Xalan XSLT processor at Apache.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

Requires(post): jpackage-utils
Requires(postun): jpackage-utils

%description javadoc
Javadoc for %{name}.

%package manual
Summary:        Manual for %{name}
Group:          Development/Libraries/Java

%description manual
Documentation for %{name}.

%package demo
Summary:        Examples for %{name}
Group:          Development/Libraries/Java

%description demo
%{summary}.

%prep
%setup -q -n BCEL_5_1
%setup -q -T -D -a 5 -n BCEL_5_1
%patch0 -p1
%patch1 -p0
%{_bindir}/find . -name "*.jar" | %{_bindir}/xargs -t %{__rm}

%if %without bootstrap
%{__mkdir_p} jakarta-site2/lib
pushd jakarta-site2/lib/
  %{_bindir}/build-jar-repository -s -p . jdom
  %{_bindir}/build-jar-repository -s -p . velocity
  %{_bindir}/build-jar-repository -s -p . commons-collections
  %{_bindir}/build-jar-repository -s -p . excalibur/avalon-logkit
  %{_bindir}/build-jar-repository -s -p . werken.xpath
  %{_bindir}/build-jar-repository -s -p . commons-lang
popd
%endif

pushd lib
  %{__ln_s} $(build-classpath regexp) Regex.jar
popd

# very broken build
%{__perl} -p -i -e 's| depends=\"examples\"||g;' build.xml
/bin/touch manifest.txt

# fix file-not-utf8
%{__mv} docs/verifier/JustIce.lyx docs/verifier/JustIce.lyx.orig
%{_bindir}/iconv -f iso-8859-1 -t utf-8 -o docs/verifier/JustIce.lyx docs/verifier/JustIce.lyx.orig
%{__rm} docs/verifier/JustIce.lyx.orig

%build
%if %with maven
export DEPCAT=$(pwd)/bcel-5.1-depcat.new.xml
/bin/echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
/bin/echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
      %{_bindir}/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
/bin/echo >> $DEPCAT
/bin/echo '</depset>' >> $DEPCAT
%{_bindir}/saxon $DEPCAT %{SOURCE2} > bcel-5.1-depmap.new.xml

for p in $(find . -name project.xml); do
    pushd $(dirname $p)
      %{__cp} -p project.xml project.xml.orig
      %{_bindir}/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

export MAVEN_HOME_LOCAL=$(pwd)/.maven
%{_bindir}/maven \
        -Dmaven.repo.remote=file:/usr/share/maven/repository \
        -Dmaven.home.local=${MAVEN_HOME_LOCAL} \
        jar:jar javadoc:generate xdoc:transform
%else
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Dbuild.dest=build/classes -Dbuild.dir=build \
        -Ddocs.src=xdocs -Djakarta.site2=jakarta-site2 -Djdom.jar=jdom.jar \
        compile jar apidocs xdocs
%endif

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}

%if %with maven
%{__install} -p -m 0644 target/%{name}-%{version}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%else
%{__install} -p -m 0644 build/%{name}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
%endif

(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{version}||g"`; done)

# depmap frags
%add_to_maven_depmap %{name} %{name} %{version} JPP %{name}
%add_to_maven_depmap org.apache.bcel %{name} %{version} JPP %{name}

# pom
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__install} -p -m 0644 %{SOURCE7} %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/%{name}-%{version}
%{__ln_s} %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with maven
%{__cp} -pr target/docs/apidocs/* %{buildroot}%{_javadocdir}/%{name}
# FIXME: (dwalluck): breaks -bi --short-circuit
%{__rm} -rf target/docs/apidocs
%else
%{__cp} -pr docs/api/* %{buildroot}%{_javadocdir}/%{name}
# FIXME: (dwalluck): breaks -bi --short-circuit
%{__rm} -rf docs/api
%endif

# samples
%{__mkdir_p} %{buildroot}%{_datadir}/%{name}-%{version}
%{__cp} -pr examples/* %{buildroot}%{_datadir}/%{name}-%{version}

# manual
%{__mkdir_p} %{buildroot}%{_docdir}/%{name}-%{version}

%if %with maven
%{__cp} -pr target/docs/* %{buildroot}%{_docdir}/%{name}-%{version}
%else
%{__cp} -pr docs/* %{buildroot}%{_docdir}/%{name}-%{version}
%endif

%if %with repolib
%{__install} -d -m 755 %{buildroot}%{repodir}
%{__install} -d -m 755 %{buildroot}%{repodirlib}
%{__install} -p -m 644 %{SOURCE6} %{buildroot}%{repodir}/component-info.xml
tag=`/bin/echo %{name}-%{version}-%{release} | %{__sed} 's|\.|_|g'`
%{__sed} -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
%{__sed} -i "s/@VERSION@/%{version}-brew/g" %{buildroot}%{repodir}/component-info.xml
%{__install} -d -m 755 %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE3} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE4} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE5} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{SOURCE7} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
%{__install} -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/bcel.jar
%endif

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
%{__rm} -rf %{buildroot}

%if %{gcj_support}
%post
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc LICENSE.txt 
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*
%if %{gcj_support}
%dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/bcel-5.1.jar.*
%endif

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files manual
%defattr(0644,root,root,0755)
%doc %{_docdir}/%{name}-%{version}

%files demo
%defattr(0644,root,root,0755)
%{_datadir}/%{name}-%{version}

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Mon Mar 02 2009 David Walluck <dwalluck@redhat.com> 0:5.1-16
- use explicit file list to avoid duplicating files between packages
- fix repolib
- properly unpack sources
- clean up build options
- fix file-not-utf8

* Tue Nov 11 2008 David Walluck <dwalluck@redhat.com> 0:5.1-15
- add maven support
- fix GCJ directory ownership

* Fri Jul 11 2008 David Walluck <dwalluck@redhat.com> 0:5.1-14
- use excalibur for avalon

* Fri Jun 13 2008 David Walluck <dwalluck@redhat.com> 0:5.1-13.jpp5
- remove spurious gnu-crypto requirement
- own %%{_libdir}/gcj/%%{name}
- fix javadoc directory

* Mon Jun 10 2008 Permaine Cheung <pcheung@redhat.com> 0:5.1-12
- Fix component-info.xml

* Tue May 27 2008 Permaine Cheung <pcheung@redhat.com> 0:5.1-11jpp
- First JPP5 build

* Fri Jul 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:5.1-1jpp.ep1.3
- Resolve namespace conflict with java.lang.Deprecated in Java 5

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:5.1-1jpp.ep1.2
- Fix repolib location

* Tue Mar 13 2007 Fernando Nasser <fnasser@redhat.com> 0:5.1-1jpp.ep1.1
- New repolib location

* Fri Feb 19 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:5.1-1jpp.el4ep1.2
- Add -brew suffix

* Fri Feb 16 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:5.1-1jpp.el4ep1.1
- Add repolib support

* Mon Nov 15 2004 Fernando Nasser <fnasser@redhat.com> 0:5.1-1jpp_3rh
- Rebuild

* Fri Mar 26 2004 Frank Ch. Eigler <fche@redhat.com> 0:5.1-1jpp_2rh
- add RHUG upgrade cleanup

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> 0:5.1-1jpp_1rh
- RH vacuuming

* Sun May 11 2003 David Walluck <david@anti-microsoft.org> 0:5.1-1jpp
- 5.1
- update for JPackage 1.5

* Mon Mar 24 2003 Nicolas Mailhot <Nicolas.Mailhot (at) JPackage.org> - 5.0-6jpp
- For jpackage-utils 1.5

e Tue Feb 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 5.0-5jpp
- Rebuild to get docdir right on modern distros.
- Fix License tag and source file perms.
- Built with IBM's 1.3.1SR3 (doesn't build with Sun's 1.4.1_01).

* Tue Jun 11 2002 Henri Gomez <hgomez@slib.fr> 5.0-4jpp
- use sed instead of bash 2.x extension in link area to make spec compatible
  with distro using bash 1.1x

* Tue May 07 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 5.0-3jpp 
- vendor, distribution, group tags

* Wed Jan 23 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 5.0-2jpp 
- section macro
- no dependencies for manual and javadoc package

* Tue Jan 22 2002 Henri Gomez <hgomez@slib.fr> 5.0-1jpp
- bcel is now a jakarta apache project
- dependency on jakarta-regexp instead of gnu.regexp 
- created manual package

* Sat Dec 8 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.4.1-2jpp
- javadoc into javadoc package
- Requires: and BuildRequires: gnu.regexp

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 4.4.1-1jpp
- removed packager tag
- new jpp extension
- 4.4.1

* Thu Oct 11 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.4.0-2jpp
- first unified release
- used lower case for name
- used original tarball
- s/jPackage/JPackage

* Mon Aug 27 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 4.4.0-1mdk
- first Mandrake release
